Label Switched Path (LSP) Object Flag Extension for Stateful PCE
RFC 9357
Quan Xiong
ZTE Corporation
No.6 Huashi Park Rd
Wuhan
Hubei
430223
China
xiong.quan@zte.com.cn
February 2023
rtg
pce
PCEP
RFC 8231 describes a set of extensions to the Path Computation Element Communication Protocol (PCEP) to enable stateful control of MPLS-TE and GMPLS Label Switched Paths (LSPs) via PCEP. One of the extensions is the LSP object, which includes a Flag field with a length of 12 bits. However, all bits of the Flag field have already been assigned.
This document defines a new LSP-EXTENDED-FLAG TLV for the LSP object for an extended Flag field.
Introduction
[RFC5440] describes the Path Computation Element Communication Protocol (PCEP), which is used between a PCE and a Path Computation Client (PCC) (or other PCE) to enable computation of Multi-protocol Label Switching for Traffic Engineering (MPLS-TE) Label Switched Paths (LSPs).
PCEP Extensions for the Stateful PCE Model [RFC8231] describes a set of extensions to PCEP to enable active control of MPLS-TE and Generalized MPLS (GMPLS) tunnels. One of the extensions is the LSP object, which contains a Flag field; bits in the Flag field are used to indicate delegation, synchronization, removal, etc.
As defined in [RFC8231], the length of the Flag field is 12 bits, and all of the bits have already been defined as shown in Table 1. This document extends the Flag field of the LSP object for other use by defining a new LSP-EXTENDED-FLAG TLV for an extended Flag field in the LSP object (see Section 3.1).
LSP Object Flag Field
Bit | Description | Reference
0 | PCE-allocation | [I-D.ietf-pce-binding-label-sid]
1 | ERO-compression | [RFC8623]
2 | Fragmentation | [RFC8623]
3 | P2MP | [RFC8623]
4 | Create | [RFC8281]
5-7 | Operational (3 bits) | [RFC8281]
8 | Administrative | [RFC8281]
9 | Remove | [RFC8281]
10 | SYNC | [RFC8281]
11 | Delegate | [RFC8281]
Conventions Used in this Document
Terminology
The terminology is defined in [RFC5440] and [RFC8231].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
PCEP Extension
The LSP object is defined in Section 7.3 of [RFC8231]. This document defines a new LSP-EXTENDED-FLAG TLV for an extended Flag field in the LSP object.
The LSP-EXTENDED-FLAG TLV
The format of the LSP-EXTENDED-FLAG TLV shown in Figure 1 follows the format of all PCEP TLVs, as defined in [RFC5440].
LSP-EXTENDED-FLAG TLV Format

 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|           Type=64             |           Length              |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|                                                               |
//                 LSP Extended Flags                          //
|                                                               |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

Type (16 bits):
64
Length (16 bits):
This indicates the length of the value portion in bytes. It MUST be in multiples of 4 and greater than 0.
LSP Extended Flags:
This contains an array of units of 32-bit flags numbered from the most significant as bit zero, where each bit represents one LSP flag (for operation, feature, or state). The LSP Extended Flags field SHOULD use the minimal amount of space needed to encode the flag bits. Currently, no bits are assigned. Unassigned bits MUST be set to zero on transmission and MUST be ignored on receipt.
As an example of usage of the LSP-EXTENDED-FLAG TLV, the E-flag is requested for entropy label configuration, as proposed in [I-D.peng-pce-entropy-label-position].
Processing
The LSP Extended Flags field is an array of units of 32 flags that are allocated starting from the most significant bit. The bits of the LSP Extended Flags field will be assigned by future documents. This document does not define any flags. Flags that an implementation is not supporting MUST be set to zero on transmission. Implementations that do not understand any particular flag MUST ignore the flag.
Note that PCEP peers MUST handle varying lengths of the LSP-EXTENDED-FLAG TLV.
If a PCEP speaker receives the LSP-EXTENDED-FLAG TLV of a length more than it currently supports or understands, it MUST ignore the bits beyond that length.
If a PCEP speaker receives the LSP-EXTENDED-FLAG TLV of a length less than the one supported by the implementation, it MUST act as if the bits beyond the length were not set.
Advice for Specification of New Flags
Following the model provided in Section 3.1 of [RFC8786], we provide the following advice for new specifications that define additional flags. Each such specification is expected to describe the interaction between these new flags and any existing flags. In particular, new specifications are expected to explain how to handle the cases when both new and preexisting flags are set. They are also expected to discuss any security implications of the additional flags (if any) and their interactions with existing flags.
Backward Compatibility
The LSP-EXTENDED-FLAG TLV defined in this document does not introduce any backward compatibility issues. An implementation that does not understand or support the LSP-EXTENDED-FLAG TLV MUST ignore the TLV, as per [RFC5440]. Future documents that define bits in the LSP-EXTENDED-FLAG TLV are expected to also define the error handling required for cases in which the LSP-EXTENDED-FLAG TLV is missing when it MUST be present.
Further, any additional bits in the LSP-EXTENDED-FLAG TLV that are not understood by an implementation MUST be ignored. It is expected that future documents that define bits in the LSP-EXTENDED-FLAG TLV will take that into consideration.
IANA Considerations
LSP Object
PCEP TLV Type Indicators
IANA has allocated the following TLV Type Indicator value within the "PCEP TLV Type Indicators" registry of the "Path Computation Element Protocol (PCEP) Numbers" registry:
Value | Description | Reference
64 | LSP-EXTENDED-FLAG | RFC 9357
LSP Extended Flags Field
IANA has created the "LSP-EXTENDED-FLAG TLV Flag Field" registry within the "Path Computation Element Protocol (PCEP) Numbers" registry to manage the LSP Extended Flags field of the LSP-EXTENDED-FLAG TLV. New values are assigned by Standards Action [RFC8126]. Each bit should be tracked with the following qualities:
- Bit number (counting from bit 0 as the most significant bit)
- Capability Description
- Reference
No values are currently defined. Bits 0-31 are initially marked as "Unassigned". Bits with a higher ordinal than 31 will be added to the registry in future documents if necessary.
Management Considerations
Implementations receiving set LSP Extended Flags that they do not recognize MAY log this. That could be helpful for diagnosing backward compatibility issues with future features that utilize those flags.
Security Considerations
[RFC8231] sets out security considerations for PCEP when used for communication with a stateful PCE. This document does not change those considerations. For LSP object processing, see [RFC8231].
The flags for the LSP object and their associated security considerations are specified in [RFC8231], [RFC8281], [RFC8623], and [I-D.ietf-pce-binding-label-sid].
This document provides for the future addition of flags in the LSP object. Any future document that specifies new flags must also discuss any associated security implications. No additional security issues are raised in this document beyond those that exist in the referenced documents. Note that [RFC8231] recommends that the stateful PCEP extension be authenticated and encrypted using Transport Layer Security (TLS) [RFC8253] [I-D.dhody-pce-pceps-tls13], as per the recommendations and best current practices in [RFC9325]. Assuming that the recommendation is followed, then the flags will be protected by TLS.
References
Normative References
Informative References
[I-D.ietf-pce-binding-label-sid]

Carrying Binding Label/Segment Identifier (SID) in PCE-based Networks.
Siva Sivabalan
Ciena Corporation
Clarence Filsfils
Cisco Systems, Inc.
Jeff Tantsura
Microsoft Corporation
Stefano Previdi
Huawei Technologies
Cheng Li, Ed.
Huawei Technologies
20 March 2022
Internet-Draft draft-ietf-pce-binding-label-sid-15
[RFC5440]
[RFC8231]
[RFC8623]
[RFC8281]
[RFC2119]
[RFC8174]
[I-D.peng-pce-entropy-label-position]
[RFC8786]
[RFC8126]
[RFC8253]
[I-D.dhody-pce-pceps-tls13]
[RFC9325]
[RFC5088]
[RFC5089]
Working Group Discussion
The working group discussed the idea of a fixed length (with 32 bits) for the LSP-EXTENDED-FLAG TLV. Though 32 bits would be sufficient for quite a while, the use of variable length with a multiple of 32 bits allows for future extensibility where we would never run out of flags and there would not be a need to define yet another TLV in the future. Further, note that [RFC5088] and [RFC5089] use the same approach for the PCE-CAP-FLAGS sub-TLV and are found to be useful.
Acknowledgements
The authors would like to thank Loa Andersson, Adrian Farrel, Aijun Wang, and Gyan Mishra for their reviews, suggestions, and comments for this document.
Contributors
The following people have substantially contributed to this document:
Dhruv Dhody
Huawei Technologies
dhruv.ietf@gmail.com
Greg Mirsky
Ericsson
gregimirsky@gmail.com